#define limit(l,a,u) (max((l),min((u),(a))))
#define sign(a) ((a)>0 ? 1 : -1)

var/const/MOVE_DELAY=2
var/const/AI_DELAY=10
var/const/BULLET_V=16
var/const/BULLET_MAXAGE=20
var/const/NUM_ASTEROIDS=100
var/NUM_MERCHANTS=2
var/NUM_GUARDS=0
var/const/PARTY_DELAY=100
var/const/NUM_PLUNDER_MESSAGE=20
var/PLUNDER_NAMES=list("dubloons","diamonds", "pieces of rare fruit", "endangered species", "internets", "standard drinks", "Wiis")
var/RANDOM_NAMES=list("Captain Zarquon", "Captain Urplebeard", "Urkle", "Captain ET", "Dfghj, scourge of Poiuyt", "Zaxqulax")
var/mob/topplayer
var/obj/upgrades/armour_button
var/obj/upgrades/bullets_button
var/obj/upgrades/accel_button

var/maxpx=world.maxx*32
var/maxpy=world.maxy*32
var/obj/wormhole/wormhole

world
	mob=/mob/spaceship
	maxx=50
	maxy=50
	view=10
	New()
		..()
		spawn(1)
			MakeMap()
			armour_button=new /obj/upgrades/repair_button()
			bullets_button=new /obj/upgrades/bullets_button()
			accel_button=new /obj/upgrades/accel_button()
			moveloop()
			for(var/mob/merchant/m) m.MerchantAI()
			for(var/mob/guard/g) g.GuardAI()


atom
	icon='Stuff.dmi'
	movable
		animate_movement=NO_STEPS
		var
			px //Xloc, pixel wise
			py //Yloc, pixel wise
			radius //Radius of bounding circle
			vx=0 //How far they're moving in the x direction. Positive right.
			vy=0 //How far they're moving in the y direction. Positive up.
			ovx=0
			ovy=0
			hp=10
			mass=10

		New()
			..()
			spawn(1) display()

		Move(mx,my)
			.=1
			if(istype(mx,/datum))
				loc=mx
				return 1
			px+=mx
			py+=my
			for(var/atom/movable/m in orange(src,1))
				if(m.density)
					if(distsquare(m,src)<=((m.radius+radius)*(m.radius+radius)))
						Bump(m)
						.=0
			if(!.)
				px-=mx
				py-=my
			if(px<16||px>maxpx-16)
				vx=-vx
				px=limit(16,px,maxpx-16)
			if(py<16||py>maxpy-16)
				vy=-vy
				py=limit(16,py,maxpy-16)
			display()

		Bump(atom/movable/m)
			var
				tm=mass+m.mass
				m1f=mass/tm
				m2f=m.mass/tm
			vx=m.ovx+(ovx-m.ovx)*m1f
			vy=m.ovy+(ovy-m.ovy)*m1f
			m.vx=ovx+(m.ovx-ovx)*m2f
			m.vy=ovy+(m.ovy-ovy)*m2f
			m.Bumped(src)

		proc
			Bumped(atom/movable/m)
				return

			display()
				var
					tx=px>>5
					ty=py>>5
				pixel_x=(px-(tx<<5))-16
				pixel_y=(py-(ty<<5))-16
				loc=locate(tx+1,ty+1,z)

			deathcheck()
				if(hp<0) death()

			death()
				del src

proc
	distsquare(atom/movable/a,atom/movable/b)
		var
			i=a.px-b.px
			j=a.py-b.py
		return (i*i)+(j*j)

	moveloop()
		set background=1
		set waitfor=0
		while(world)
			topplayer=findtopplayer()
			for(var/atom/movable/m)
				m.ovx=m.vx
				m.ovy=m.vy
			for(var/atom/movable/m)	m.Move(m.vx,m.vy)
			sleep(MOVE_DELAY)

	atan2(a,b)
		if(a==0) return b>=0 ? 90 : 270
		.=atan(b/a)*sign(b)
		if(a<0)
			.+=180
			.=-.

	atan(x)
		return arcsin(x/sqrt(1+x*x))*sign(x)

	findtopplayer()
		var/mob/spaceship/m
		for(var/mob/spaceship/s) if(!m||s.points>m.points) m=s
		return m

	MakeMap()
		set background=1
		set waitfor=0
		wormhole=new
		for(var/a=1, a<=NUM_ASTEROIDS, a++) new /obj/asteroid
		while(1)
			MakeMerchantParty()
			MakeAsteroids()
			sleep(PARTY_DELAY)

	MakeAsteroids()
		var/startx=pick(1,world.maxx)
		var/starty=pick(1,world.maxy)
		var/obj/asteroid/a=new
		var/rx=rand(-64,64)
		var/ry=rand(-64,64)
		a.loc=locate(startx,starty,1)
		a.px=startx*32+rx
		a.py=starty*32+ry

	MakeMerchantParty()
		var/startx=pick(1,world.maxx)
		var/starty=pick(1,world.maxy)
		var/nm=rand(1,NUM_MERCHANTS)
		var/ng=rand(1,NUM_GUARDS)
		for(var/a=1, a<=nm, a++)
			var/mob/merchant/m=new
			var/rx=rand(-64,64)
			var/ry=rand(-64,64)
			m.loc=locate(startx,starty,1)
			m.px=startx*32+rx
			m.py=starty*32+ry
			m.MerchantAI()

		for(var/a=1, a<=ng, a++)
			var/mob/guard/m=new
			var/rx=rand(-64,64)
			var/ry=rand(-64,64)
			m.loc=locate(startx,starty,1)
			m.px=startx*32+rx
			m.py=starty*32+ry
			m.GuardAI()

		NUM_MERCHANTS+=0.1
		NUM_GUARDS+=0.1

obj
	upgrades
		var/cost
		New()
			..()
			suffix=cost
		repair_button
			name="Increase ship armour for 50 bananas"
			cost=50
			icon_state="rb"
			Click()
				if(usr.points>cost)
					usr.hp+=10
					usr.points-=cost

		bullets_button
			name="Upgrade bullet damage for 200 bananas"
			cost=200
			icon_state="bb"
			Click()
				if(usr.points>cost)
					usr.power++
					usr.points-=cost

		accel_button
			name="Upgrade ship acceleration for 500 bananas"
			cost=500
			icon_state="ab"
			Click()
				if(usr.points>cost)
					usr.accel+=2
					usr.points-=cost

	wormhole
		radius=16
		density=1
		mass=0
		icon_state="wormhole"
		New()
			px=maxpx>>1
			py=maxpy>>1
			vx=0
			vy=0
			loc=locate(world.maxx/2,world.maxy/2,1)
			..()

		Bump(atom/movable/m)
			del m
			vx=0
			vy=0
			hp+=10

		Bumped(atom/movable/m)
			del m
			vx=0
			vy=0
			hp+=10

		death()
			return

	asteroid
		radius=16
		density=1
		icon_state="asteroid"
		hp=5
		New()
			px=rand(16,maxpx-16)
			py=rand(16,maxpy-16)
			vx=rand(-8,8)
			vy=rand(-8,8)
			loc=locate(1,1,1)
			..()

		death()
			var/k=rand(1,4)
			for(var/a=1,a<=k,a++)
				var/obj/rockchunk/r=new
				r.px=px+rand(-16,16)
				r.py=py+rand(-16,16)
				r.loc=loc
				r.vx=vx+rand(-4,4)
				r.vy=vy+rand(-4,4)
			..()

	rockchunk
		radius=2
		density=1
		icon_state="rockchunk"
		mass=1
		hp=1

	metalchunk
		radius=2
		density=1
		icon_state="metalchunk"
		mass=1
		hp=1

	laser
		radius=2
		density=1
		icon_state="laser"
		mass=0.1
		var
			age
			damage

		Move()
			.=..()
			age++
			if(age>=BULLET_MAXAGE) del src

		Bump(atom/movable/m)
			m.hp-=damage
			m.deathcheck()
			del src

		Bumped(atom/movable/m)
			m.hp-=damage
			m.deathcheck()
			del src

		death()
			return

	pickup
		radius=3
		density=1
		icon_state="pickup"
		mass=2
		var
			worth

		Bump(mob/m)
			..()
			if(ismob(m)&&m.client)
				m.points+=worth
				PickupMessage(m)
				del src
			hp+=10

		Bumped(mob/m)
			..()
			if(ismob(m)&&m.client)
				m.points+=worth
				PickupMessage(m)
				del src
			hp+=10

		proc/PickupMessage(mob/m)
			m << "You plunder yeself [rand(2,NUM_PLUNDER_MESSAGE)] "+pick(PLUNDER_NAMES)

		death()
			return

turf
	space
		icon_state="space"

mob
	var
		points=0
		power=1
		accel=2

	death()
		var/obj/pickup/p=new
		p.loc=loc
		p.px=px
		p.py=py
		p.vx=vx+rand(-4,4)
		p.vy=vy+rand(-4,4)
		p.worth=points
		var/k=rand(1,4)
		for(var/a=1,a<=k,a++)
			var/obj/metalchunk/r=new
			r.px=px+rand(-16,16)
			r.py=py+rand(-16,16)
			r.loc=loc
			r.vx=vx+rand(-4,4)
			r.vy=vy+rand(-4,4)
		..()

	proc
		fire(atom/movable/m)
			var/obj/laser/l=new
			var/ang
			if(!isturf(m)) ang=atan2(m.py-py,m.px-px)
			else ang=atan2(m.y-y, m.x-x)
			l.vx=sin(ang)*BULLET_V
			l.vy=cos(ang)*BULLET_V
			l.px=px+l.vx
			l.py=py+l.vy
			l.loc=loc
			l.damage=power

	spaceship
		icon_state="pirate"
		px=32
		py=32
		radius=4
		mass=5
		Stat()
			if(statpanel("Statistics"))
				stat("Ship armour:",hp)
				stat("Points:",points)
				stat("Location:","[x],[y]")
				if(topplayer) stat("Top player, with [topplayer.points]",topplayer)
			if(statpanel("Upgrades"))
				stat(armour_button)
				stat(bullets_button)
				stat(accel_button)

		Login()
			..()
			suffix=key
			name=pick(RANDOM_NAMES)
			world << "[key], better known as [name], has joined ye in your plunderin' adventures"
			src << new /image('Stuff.dmi',src,"yourship")

		New()
			vx=0
			vy=0
			loc=locate(1,1,1)
			px=(maxpx/2)+rand(-256,256)
			py=(maxpy/2)+rand(-256,256)
			..()

		death()
			world << "Hardy-har! [key], better known as [name], has been shot down with [points] points!"
			client.mob=new /mob/spaceship
			..()

	merchant
		icon_state="merchant"
		radius=9
		mass=10
		hp=2
		accel=1

		proc/MerchantAI()
			set background=1
			set waitfor=0
			while(src)
				var/ang=atan2(wormhole.py-py,wormhole.px-px)
				var/ex=sin(ang)
				var/ey=cos(ang)
				for(var/mob/spaceship/s in range(src))
					ang=atan2(py-s.py,px-s.px)
					ex+=sin(ang)
					ey+=cos(ang)

				ang=atan2(ey,ex)
				vx+=sin(ang)*accel
				vy+=cos(ang)*accel
				sleep(AI_DELAY)

		New()
			..()
			points=rand(21,50)

	guard
		icon_state="guard"
		radius=4
		mass=5
		accel=1
		hp=1
		power=0.2
		New()
			points=rand(1,20)

		proc/GuardAI()
			set background=1
			set waitfor=0
			while(src)
				var/inrange=0
				var/ang=0
				var/wang=atan2(wormhole.py-py,wormhole.px-px) //Now, we can all be reasonably mature about this, I hope?
				var/ex=0
				var/ey=0
				for(var/mob/spaceship/s in range(src))
					inrange=1
					ang=atan2(s.py-py,s.px-px)
					ex+=sin(ang)
					ey+=cos(ang)

				if(!inrange)
					ex+=sin(wang)*accel
					ey+=cos(wang)*accel

				inrange=0
				ang=atan2(ey,ex)
				vx+=sin(ang)*accel
				vy+=cos(ang)*accel
				for(var/mob/spaceship/s in range(src))
					fire(s)
					break
				sleep(AI_DELAY)

client
	lazy_eye=3
	North()
		mob.vy+=mob.accel

	South()
		mob.vy-=mob.accel

	East()
		mob.vx+=mob.accel

	West()
		mob.vx-=mob.accel

	Click(atom/movable/m)
		..()
		if(!istype(m,/obj/upgrades)) mob.fire(m)

	New()
		.=..()
		spawn(1) src << browse(file2text('help.txt'))